Bug 1770582 (jlems) - Review Request: jlems - Java Interpreter for the Low Entropy Model Specification language
Summary: Review Request: jlems - Java Interpreter for the Low Entropy Model Specificat...
Keywords:
Status: CLOSED ERRATA
Alias: jlems
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro
TreeView+ depends on / blocked
 
Reported: 2019-11-10 17:58 UTC by Ankur Sinha (FranciscoD)
Modified: 2019-12-17 02:29 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-12-17 01:44:55 UTC
Type: ---
loganjerry: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2019-11-10 17:58:20 UTC
Spec URL: https://ankursinha.fedorapeople.org/jLEMS/jLEMS.spec
SRPM URL: https://ankursinha.fedorapeople.org/jLEMS/jLEMS-0.9.9.1-1.fc32.src.rpm

Description: 
Java Interpreter for the Low Entropy Model Specification language.

See http://lems.github.com/LEMS

For more details on LEMS see:

Robert C. Cannon, Padraig Gleeson, Sharon Crook, Gautham Ganapathy, Boris
Marin, Eugenio Piasini and R. Angus Silver, LEMS: A language for expressing
complex biological models in concise and hierarchical form and its use in
underpinning NeuroML 2, Frontiers in Neuroinformatics 2014, doi:
10.3389/fninf.2014.00079


Fedora Account System Username: ankursinha

Comment 1 Jerry James 2019-11-12 16:54:56 UTC
I will take this review.  Can you take bug 1765730 in exchange?

Comment 2 Zbigniew Jędrzejewski-Szmek 2019-11-12 17:40:30 UTC
jLEMS → jlems.

Comment 3 Jerry James 2019-11-12 17:45:04 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
1. Package does not contain duplicates in %files.
   Note: warning: File listed twice: /usr/share/java/jLEMS
   See: https://docs.fedoraproject.org/en-US/packaging-
   guidelines/#_duplicate_files

   Remove %dir %{_javadir}/%{name} from %files to fix this.  It is included in
   .mfiles.

2. $ lems 1 2 3 4
   Running the LEMS application...
   Error: Could not find or load main class org.lemsml.jlems.viz.VizMain

   Perhaps CLASSPATH should be set to %{_javadir}/%{name}/jlems.jar in %{_bindir}/lems?

3. https://docs.fedoraproject.org/en-US/packaging-guidelines/Naming/#_case_sensitivity
   Does the package name need to contain uppercase letters?

4. These two manual dependencies:

   Requires:       java-headless
   Requires:       javapackages-filesystem

   are generated automatically, so do not need to be in the spec file.

5. The tests are not run.  Can you add a %check script to do so?

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
     But see the question above about upper case letters in the name.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[-]: Bundled jar/class files should be removed before build

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: jLEMS-0.9.9.1-1.fc32.noarch.rpm
          jLEMS-javadoc-0.9.9.1-1.fc32.noarch.rpm
          jLEMS-0.9.9.1-1.fc32.src.rpm
jLEMS.noarch: W: spelling-error %description -l en_US doi -> dpi, do, oi
jLEMS.noarch: W: spelling-error %description -l en_US fninf -> inf
jLEMS.noarch: W: no-manual-page-for-binary lems
jLEMS.src: W: spelling-error %description -l en_US doi -> dpi, do, oi
jLEMS.src: W: spelling-error %description -l en_US fninf -> inf
3 packages and 0 specfiles checked; 0 errors, 5 warnings.


Rpmlint (installed packages)
----------------------------
jLEMS.noarch: W: spelling-error %description -l en_US doi -> dpi, do, oi
jLEMS.noarch: W: spelling-error %description -l en_US fninf -> inf
jLEMS.noarch: W: no-manual-page-for-binary lems
2 packages and 0 specfiles checked; 0 errors, 3 warnings.


Source checksums
----------------
https://github.com/LEMS/jLEMS/archive/v0.9.9.1/jLEMS-0.9.9.1.tar.gz :
  CHECKSUM(SHA256) this package     : e61e6a656cb4feeb76a4e0a16b4cf3d1ea0d26a5e021642f6928c90d3d639b60
  CHECKSUM(SHA256) upstream package : e61e6a656cb4feeb76a4e0a16b4cf3d1ea0d26a5e021642f6928c90d3d639b60


Requires
--------
jLEMS (rpmlib, GLIBC filtered):
    /usr/bin/sh
    java-headless
    javapackages-filesystem

jLEMS-javadoc (rpmlib, GLIBC filtered):
    javapackages-filesystem



Provides
--------
jLEMS:
    jLEMS
    mvn(org.lemsml:jlems)
    mvn(org.lemsml:jlems:pom:)

jLEMS-javadoc:
    jLEMS-javadoc



Generated by fedora-review 0.7.3 (44b83c7) last change: 2019-09-18
Command line :/usr/bin/fedora-review -b 1770582 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-{{ target_arch }}
Active plugins: Generic, Java, Shell-api
Disabled plugins: fonts, SugarActivity, Python, Ruby, C/C++, R, PHP, Haskell, Perl, Ocaml
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 4 Ankur Sinha (FranciscoD) 2019-12-02 20:18:18 UTC
Thanks for the review, Jerry. Sorry for the delay.


(In reply to Jerry James from comment #3)
> Package Review
> ==============
> 
> Legend:
> [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> [ ] = Manual review needed
> 
> 
> Issues:
> =======
> 1. Package does not contain duplicates in %files.
>    Note: warning: File listed twice: /usr/share/java/jLEMS
>    See: https://docs.fedoraproject.org/en-US/packaging-
>    guidelines/#_duplicate_files
> 
>    Remove %dir %{_javadir}/%{name} from %files to fix this.  It is included
> in
>    .mfiles.

Fixed.


> 
> 2. $ lems 1 2 3 4
>    Running the LEMS application...
>    Error: Could not find or load main class org.lemsml.jlems.viz.VizMain
> 
>    Perhaps CLASSPATH should be set to %{_javadir}/%{name}/jlems.jar in
> %{_bindir}/lems?

Fixed.

> 
> 3.
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Naming/
> #_case_sensitivity
>    Does the package name need to contain uppercase letters?


LEMS is an acronym, so yes, I'd like to keep it in uppercase. The python package is also similarly uppercase:
https://src.fedoraproject.org/rpms/python-PyLEMS

> 
> 4. These two manual dependencies:
> 
>    Requires:       java-headless
>    Requires:       javapackages-filesystem
> 
>    are generated automatically, so do not need to be in the spec file.

Removed.

> 
> 5. The tests are not run.  Can you add a %check script to do so?

FIXED: Maven tests enabled, and examples run as additional tests too.


Spec URL: https://ankursinha.fedorapeople.org/jLEMS/jLEMS.spec
SRPM URL: https://ankursinha.fedorapeople.org/jLEMS/jLEMS-0.9.9.1-2.fc32.src.rpm

Cheers,
Ankur

Comment 5 Zbigniew Jędrzejewski-Szmek 2019-12-03 09:18:28 UTC
> LEMS is an acronym, so yes, I'd like to keep it in uppercase.

The problem is that nobody can remember the exact casing of packages when
they're not using the package regularly, and a name like "jLEMS" or
"python-PyLEMS" is simply a PITA. For example, the name of the Python
project starts with an uppercase letter, but the package name is still
lowercase. Note that with pylems with have "py" and "Py" in the name of one
package.

It's the same story with dashes-vs-underscores: projects are not consistent,
and then it becomes hard to remember which one was used. Settling on a
consistent and easy-to-memorize policy avoids the issue.

https://docs.fedoraproject.org/en-US/packaging-guidelines/Naming/#_general_naming:
> Package names SHOULD be in lower case and use dashes in preference to underscores.

Comment 6 Ankur Sinha (FranciscoD) 2019-12-03 11:29:00 UTC
I get that, but this is specialist software---not general software for anyone to use. Most people will not just try "sudo dnf install jlems". They will be aware that it is "jLEMS" that they are looking for, matching the upstream name.

In the case of PyLEM alsoS, it matches the pip command that people will be used to: `pip install PyLEMS`: https://pypi.org/project/PyLEMS/

Even in literature, this is referred to as LEMS, not lems: https://www.frontiersin.org/articles/10.3389/fninf.2014.00079/full

So, here I argue that LEMS is better known by the target audience than lems.


In general can I not also just add Provides: jlems so that both cases are taken care of?

Comment 7 Zbigniew Jędrzejewski-Szmek 2019-12-03 12:29:06 UTC
The guidelines are "should", not "must", so it is ultimately your decision.
But this is a Fedora package name, so what matters if Fedora rules. I think
"Provides: PyLEMS" would be more appropriate then the other way around.
In particular, then 'dnf install PyLEMS' will work (without the "python-" prefix).

Comment 8 Jerry James 2019-12-03 19:00:31 UTC
(In reply to Ankur Sinha (FranciscoD) from comment #4)
> Thanks for the review, Jerry. Sorry for the delay.

No problem.  I would like to draw your attention to comment 1, in case that has escaped your notice.

The package is looking good.  I will wait for your response to comment 7 before we wrap this up.

Comment 9 Ankur Sinha (FranciscoD) 2019-12-06 20:22:12 UTC
Thanks, I've renamed it to jlems now:

Spec: https://ankursinha.fedorapeople.org/jlems/jlems.spec
SRPM: https://ankursinha.fedorapeople.org/jlems/jlems-0.9.9.1-3.fc32.src.rpm

(Reviewing the gap package now, sorry---missed the comment!)

Comment 10 Jerry James 2019-12-06 22:56:15 UTC
(In reply to Ankur Sinha (FranciscoD) from comment #9)
> Thanks, I've renamed it to jlems now:

Okay, everything looks good.  This package is APPROVED.

> (Reviewing the gap package now, sorry---missed the comment!)

No worries.  I kind of figured that was what had happened.

Comment 11 Igor Raits 2019-12-07 20:12:19 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/jlems

Comment 12 Fedora Update System 2019-12-08 09:49:29 UTC
FEDORA-2019-0d74a37e51 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-0d74a37e51

Comment 13 Fedora Update System 2019-12-08 09:49:29 UTC
FEDORA-2019-2057b083c3 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-2057b083c3

Comment 14 Fedora Update System 2019-12-09 02:54:33 UTC
jlems-0.9.9.1-3.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-2057b083c3

Comment 15 Fedora Update System 2019-12-09 03:19:43 UTC
jlems-0.9.9.1-3.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-0d74a37e51

Comment 16 Fedora Update System 2019-12-17 01:44:55 UTC
jlems-0.9.9.1-3.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2019-12-17 02:29:04 UTC
jlems-0.9.9.1-3.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.